display = {}
display.x = 640
display.y = 0
display.width = 224
display.height = 640
display.center = display.x + (display.width / 2)
display.maininfo = true
display.propinfo = false
display.dipinfo = false
display.settings = false
local mx, my = 0, 0

function display:load()
	overlay1 = love.graphics.newImage("Images/layer.png")
	overlay2 = love.graphics.newImage("Images/layer2.png")
	ind = love.graphics.newImage("Images/ind.png")
	button = love.graphics.newImage("Images/button.png")
	line = love.graphics.newImage("Images/popoutline.png")
end

function display:toggle()
	if display.maininfo then
		display.maininfo = false
		display.propinfo = true
	elseif display.propinfo then
		display.propinfo = false
		display.dipinfo = true
	elseif display.dipinfo then
		display.dipinfo = false
		display.settings = true
	elseif display.settings then
		display.settings = false
		display.maininfo = true
	end
end

function display:getMouse(x, y)
	mx, my = x, y
end




function display:drawtext(text, font, color, xpos, ypos, align)
	local font = font
	local text = text
	local color = color
	local xpos = xpos
	local ypos = ypos
	local align = align
	love.graphics.setFont(font)
	love.graphics.setColor(color)
	if align == "c" then
		local offset = font:getWidth(text) / 2
		love.graphics.print(text, self.center - offset, ypos)
	end
	if align == "r" then
		local offset = font:getWidth(text)
		love.graphics.print(text, self.x + xpos - offset, ypos)
	end
	if align == "l" then
		love.graphics.print(text, self.x + xpos, ypos)
	end
end

function display:stat(text, y1, y2, v1, v2, y3)
	local text = text
	local y1 = y1
	local y2 = y2
	local v1 = v1
	local v2 = v2
	local y3 = y3
	self:drawtext(text, bold10, {255,255,255}, 10, y1, "l")
	love.graphics.setColor(255, 0, 0)
	love.graphics.rectangle("fill", self.x + 20, y2, 184, 20)
	love.graphics.setColor(0, 255, 0)
	love.graphics.rectangle("fill", self.x + 20, y2, (v1/v2)*184, 20)
	self:drawtext("("..v1.."/"..v2..")", font10, {255,255,255}, nil, y3, "c")
	love.graphics.draw(ind, self.x + 20, y2)
end

function display:draw(v, x, y, date, p)
	local v = v
	love.graphics.setColor(25, 25, 25)
	love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)


	if self.maininfo then
		local statcolor = v[2] == "Friendly" and {0,255,0} or v[2] == "Hostile" and {255,0,0} or {64,64,64}

		self:drawtext(v[1], bold10, {255,255,255}, nil, 4, "c")
		self:drawtext(v[2], bold10, statcolor, nil, 27, "c")
		self:drawtext("["..x..","..y.."]", bold10, {255,255,255}, nil, 51, "c")

		self:drawtext("Faction: ", bold10, {255,255,255}, 10, 76, "l")
		self:drawtext(v[3], font10, {255,255,255}, 214, 88, "r")

		self:drawtext("Population: ", bold10, {255,255,255}, 10, 100, "l")
		self:drawtext(commaFormat(v[4]), font10, {255,255,255}, 214, 112, "r")

		self:drawtext("Clock: "..date[4].." : "..date[3].." : "..date[2].." : "..date[1], font10, {255,255,255}, 10, 550, "c") --Running Time
		self:drawtext("Day: "..date[5].." Month: "..date[6], font10, {255,255,255}, 10, 579, "c") -- Galaxy Calender

		--start drawing the players information and current ship
		self:drawtext("Currency: ", bold10, {255,255,255}, 10, 495, "l")
		self:drawtext(commaFormat(p.currency), font10, {255,255,255}, 214, 495, "r")

		self:drawtext("Faction: ", bold10, {255,255,255}, 10, 507, "l")
		self:drawtext(p.faction, font10, {255,255,255}, 214, 507, "r")

		self:drawtext("Rank: ", bold10, {255,255,255}, 10, 519, "l")
		self:drawtext(p.rank, font10, {255,255,255}, 214, 519, "r")

		--Ship Info

		self:drawtext(p.ship.name, bold12, {255,255,255}, nil, 144, "c")
		self:drawtext(p.ship.model.." Class", bold10, {255,255,255}, nil, 160, "c")

		display:stat("Hull", 179, 201, p.ship.hull, p.ship.hullcap, 202)
		display:stat("Shield", 229, 251, p.ship.shield, p.ship.shield, 252)
		display:stat("Weaponry", 279, 301, p.ship.weapcount, p.ship.weapcap, 302)
		if mx >= self.x + 20 and mx <= self.x + 204 and	my >= 301 and my <= 321 then
			love.graphics.setColor(255,255,255)
			love.graphics.draw(line, self.x-200, self.y + 301)

			love.graphics.setColor(25, 25, 25, 175)
			love.graphics.rectangle("fill", self.x -200, self.y + 301, 200, 400)
			local c1 = 4
			local c2 = 17
			for i,v in ipairs(p.ship.weapons) do
				if v.q > 1 then 
					self:drawtext(v.name.." x"..v.q, bold10, {255,255,255, 175}, -190, 301 + c1, "l")
				else
					self:drawtext(v.name, bold10, {255,255,255, 175}, -190, 301 + c1, "l")
				end
				-- firerate = 2, damage = 20, accuracy =
				self:drawtext("R:"..v.firerate.." D:"..v.damage.." A:"..v.accuracy, font10, {255,255,255, 125}, -12, 300 + c2, "r")
				c1 = c1 + 26
				c2 = c2 + 26
			end
		end


		display:stat("Cargo", 329, 351, p.ship.cargowt, p.ship.cargocap, 352)
		if mx >= self.x + 20 and mx <= self.x + 204 and	my >= 351 and my <= 371 then
			love.graphics.setColor(255,255,255)
			love.graphics.draw(line, self.x-200, self.y + 351)

			love.graphics.setColor(25, 25, 25, 175)
			love.graphics.rectangle("fill", self.x -200, self.y + 351, 200, 350)
			local c1 = 4
			local c2 = 17
			if p.ship.cargo[1] ~= nil then
				for i,v in ipairs(p.ship.cargo) do
					if v.q > 1 then
						self:drawtext(v.name.." x"..v.q, bold10, {255,255,255, 175}, -190, 351 + c1, "l")
					else
						self:drawtext(v.name, bold10, {255,255,255, 175}, -190, 351 + c1, "l")
					end
					-- firerate = 2, damage = 20, accuracy =
					self:drawtext("W:"..v.weight.." T:"..v.totalweight, font10, {255,255,255, 125}, -12, 351 + c2, "r")
					c1 = c1 + 26
					c2 = c2 + 26
				end
			else
				self:drawtext("None", bold10, {255,255,255, 175}, -140, 351 + c1, "l")
			end
		end

		display:stat("Passengers", 379, 401, p.ship.passengerct, p.ship.passcap, 402)
		if mx >= self.x + 20 and mx <= self.x + 204 and	my >= 401 and my <= 421 then
			love.graphics.setColor(255,255,255)
			love.graphics.draw(line, self.x-200, self.y + 401)

			love.graphics.setColor(25, 25, 25, 175)
			love.graphics.rectangle("fill", self.x -200, self.y + 401, 200, 300)
			local c1 = 4
			local c2 = 17
			if p.ship.passengers[1] ~= nil then
				for i,v in ipairs(p.ship.passengers) do
					if v.q > 1 then
						self:drawtext(v.title.." x"..v.q, bold10, {255,255,255, 175}, -190, 401 + c1, "l")
					else
						self:drawtext(v.title, bold10, {255,255,255, 175}, -190, 401 + c1, "l")
					end
					-- --title, class, level, cost, weapon
					self:drawtext("C:"..v.class.." L:"..v.level.." W:"..v.weapon, font10, {255,255,255, 125}, -12, 401 + c2, "r")
					c1 = c1 + 26
					c2 = c2 + 26
				end
			else
				self:drawtext("None", bold10, {255,255,255, 175}, -140, 351 + c1, "l")
			end

		end


		display:stat("Hyper Battery", 429, 451, p.ship.hyper, p.ship.hypercap, 452)



		--Overlay
		love.graphics.setColor(255,255,255)
		love.graphics.draw(overlay1, self.x, self.y)
	elseif display.propinfo then
		self:drawtext("Management", font10, {45,182,255}, nil, 75, "c")

		--overlay
		love.graphics.setColor(255,255,255)
		love.graphics.draw(overlay2, self.x, self.y)
	elseif display.dipinfo then
		self:drawtext("Diplomacy", font10, {45,182,255}, nil, 75, "c")




		--overlay
		love.graphics.setColor(255,255,255)
		love.graphics.draw(overlay2, self.x, self.y)
	elseif display.settings then
		self:drawtext("Settings", font10, {45,182,255}, nil, 75, "c")



		--overlay
		love.graphics.setColor(255,255,255)
		love.graphics.draw(overlay2, self.x, self.y)
	end
	--static buttons
	love.graphics.setColor(255,255,255)
	love.graphics.draw(button, self.x + 4, 608)
	love.graphics.draw(button, self.x + 59, 608)
	love.graphics.draw(button, self.x + 116, 608)
	love.graphics.draw(button, self.x + 172, 608)



end

function commaFormat(n)
  return tostring(math.floor(n)):reverse():gsub("(%d%d%d)","%1,")
                                :gsub(",(%-?)$","%1"):reverse()
end



