hyper = {}

hyper.destination = {}
hyper.runtime = 0
hyper.done = true

function hyper:text(text, ypos)
	local font = bold16
	local text = text
	local color = {255,255,255}
	local ypos = ypos
	local offset = font:getWidth(text) / 2
	local center = love.graphics.getWidth()/2
	love.graphics.setFont(font)
	love.graphics.setColor(color)
	love.graphics.print(text, center - offset, ypos)
end

function hyper:enter(destination)
	self.runtime = 0
	self.destination = destination
	self.done = false
end


function hyper:complete() --return the coords
		return self.destination
end


function hyper:update(dt)
	local centerx = love.graphics.getWidth()/2
	self.runtime = self.runtime + dt

	if self.runtime >= 16 then
		self.done = true
	end
end

function hyper:draw()
		love.graphics.draw(hyperscreen, 0, 0)
		if self.runtime >= 0 then
			hyper:text("Initiating Hyper Drive", 50)
		end
		if self.runtime >= 1 then
			hyper:text("Coordinates ( " .. self.destination[1] .. " , " .. self.destination[2] .. " ) entered into the Navigation System", 100)
		end
		if self.runtime >= 2 then
			hyper:text("Engaging Thrusters", 150)
		end
		if self.runtime >= 3 then
			hyper:text("Hyperspace Entered", 200)
		end
		if self.runtime >= 5 then
			hyper:text("...Travelling...", 250)
		end
		if self.runtime >= 7 then
			hyper:text("...Travelling...", 300)
		end
		if self.runtime >= 9 then
			hyper:text("Nearing Destination", 350)
		end
		if self.runtime >= 10 then
			hyper:text("Hyperspace Exited", 400)
		end
		if self.runtime >= 11 then
			hyper:text("Deceleration in Progress", 450)
		end
		if self.runtime >= 14 then
			hyper:text("Hyper Travel Complete", 500)
		end

end















































