
require "player"
require "system"
require "map"
require "display"
require "jump"
require "economy"
require "resources"
require "diplomacy"
require "interact"
require "hovertips"


function love.load()
	player.load()
	system.load()
	display.load()
	gamemode = "play"
	gamestate = "move"
	font10 =  love.graphics.newFont("Fonts/pf_tempesta_seven.ttf", 10 )
	font12 =  love.graphics.newFont("Fonts/pf_tempesta_seven.ttf", 12 )
	font16 =  love.graphics.newFont("Fonts/pf_tempesta_seven.ttf", 16 )
	bold10 =  love.graphics.newFont("Fonts/pf_tempesta_seven_bold.ttf", 10 )
	bold12 =  love.graphics.newFont("Fonts/pf_tempesta_seven_bold.ttf", 12 )
	bold16 =  love.graphics.newFont("Fonts/pf_tempesta_seven_bold.ttf", 16 )
	hyperscreen = love.graphics.newImage("Images/Travel.png")
	mapoverlay = love.graphics.newImage("Images/moveborder.png")
	trading1 = love.graphics.newImage("Images/t1.png")
	trading2 = love.graphics.newImage("Images/t2.png")
	fkey = love.graphics.newImage("Images/fkey.png")


end

function love.keypressed(key)
	if key == "escape" then -- to be moved to menu to ext, play to go to menu
		love.event.quit()
	end

	if gamemode == "menu" then

	elseif gamemode == "play" then
		if key == "i" then --to include a not battle or hyper
			display:toggle()
		end
		if gamestate == "move" then
			if key == "m" then
				map:start(player.coords[1], player.coords[2])
				gamestate = "map"
			end
			if key == "f" then
				interact:set(system.current, player.x, player.y)
				if interact.launch then
					gamestate = "interact"
				end
			end
		elseif gamestate == "interact" then
			if key == "f" then
				interact:complete()
				gamestate = "move"
			end
		elseif gamestate == "map" then
			if key == "m" then
				gamestate = "move"
				map:complete()
			end
			if key == "b" then
				map:hidewaypoint()
			end
			if key == "j" then
				if player.ship.hyper >= 100 then
					if map:canJump(player.coords) then
						player.ship.hyper = player.ship.hyper - 100
						hyper:enter(map.waypoint) --start the hyperjump process
						map:complete() --reset the offset
						map:hidewaypoint() --clear the waypoint
						gamestate = "jump"
					end
				end
			end
		end
	end
end


function love.mousereleased(x, y, button)
	if gamemode == "menu" then

	elseif gamemode == "play" then


		if gamestate == "move" then


		elseif gamestate == "map" then
			if button =="l" then
				map:setwaypoint()
			end
		end
	end
end



function love.update(dt)
	if gamemode == "play" then
	clock:update(dt)
	local mx, my = love.mouse.getPosition()
		if gamestate == "move" then
			player:update(dt)
			system:update(player.coords[1],player.coords[2], mx, my)
		elseif gamestate == "interact" then
			interact:update()
		elseif gamestate == "map" then
			map:adjust()
			map:getRectCoords(player.coords[1], player.coords[2], mx, my)
		elseif gamestate == "jump" then
			hyper:update(dt)
			if hyper.done then
				player:updcoords(hyper:complete()) --set the player coords to the destination
				gamestate = "move"
			end
		end
		if gamestate == "move" or gamestate == "map" or "interact" then
			display:getMouse(mx,my)
		end
	end
end

function love.draw()
	if gamemode == "menu" then

	end

	if gamemode == "play" then
		if gamestate == "move" then
			system:draw()
			player:draw()
			functionKey(player.x, player.y, system.current)
			system:finalLayer()
		elseif gamestate == "map" then
			map:draw(system.list, player.coords[1], player.coords[2])
			map:hoverinfo()
		elseif gamestate == "interact" then
			interact:draw()
		elseif gamestate == "jump" then
			hyper:draw()
		end
		if gamestate == "move" or gamestate == "map" or gamestate == "interact" then
			display:draw(system:info(), player.coords[1], player.coords[2], clock:date(), player)
			love.graphics.setColor(255,255,255) -- This overlay will be for menu buttons, hover and it will display the menu
			love.graphics.draw(mapoverlay, 0, 0)
		end
	end
end
