
--When systems are loaded, adda value to make them hidden y/n, makes the waypoint more beneficial for quests, once you dinf it, it becomes unhidden and shows up on the map


map = {}

map.grid = 16
map.view = {320,320}
map.offset = {0,0}
map.waypoint = {}
map.alerts = {}
map.rcoords = {} -- for the overall systems grid(for printing and settings waypoints)
map.rgrid = {} -- used for the local grid
map.slist = {}
local mposx, mposy


function map:text(text, x, y) --Move this to a RendText file to be used by display and map, possibly menu.
	local text = text
	local xpos = x
	local ypos = y
	love.graphics.setFont(font12)
	love.graphics.setColor(255,255,255)
	love.graphics.print(text, xpos, ypos)
end


function map:start(x, y) --upon entering the map, it centers on system the player is in
	self.view = {320 - x * self.grid, 320 - y * self.grid}
end

function map:complete()
	self.offset = {0,0}
end


function map:getRectCoords(pxc, pyc, mx, my) --Also updates the mouse position for the entire map.lua
	mposx, mposy = mx, my --sets the local mouse x and y for the module
	self.rgrid[1] = math.floor(mposx/self.grid)
	self.rgrid[2] = math.floor(mposy/self.grid)
	self.rcoords = {self.rgrid[1] - 20 + pxc - (self.offset[1]/16), self.rgrid[2] - 20 + pyc - (self.offset[2]/16)} --gets the coords based on the rect that is returned from the getrect command, then adjusts it based on the view and offset
end


function map:adjust()
	if love.keyboard.isDown("a") then
		self.offset[1] = self.offset[1] + 16

	elseif love.keyboard.isDown("s") then
		self.offset[2] = self.offset[2] - 16

	elseif love.keyboard.isDown("d") then
		self.offset[1] = self.offset[1] - 16

	elseif love.keyboard.isDown("w") then
		self.offset[2] = self.offset[2] + 16
	end
end



function map:draw(list, pxc, pyc)
	local r = self.grid/2
	self.slist = list
	-- Draw system dots
	for k, s in ipairs(self.slist) do
		if not s.hidden then
			local colorl = s.status == "Friendly" and {0,255,0} or s.status == "Hostile" and {255,0,0} or {64,64,64}
			love.graphics.setColor(colorl)
			love.graphics.circle( "fill", s.coords[1] * self.grid + self.view[1] + r + self.offset[1], s.coords[2] * self.grid + self.view[2] + r + self.offset[2], r, 100 )
		end
	end

	--draw the square the mouse is hovering over
	love.graphics.setColor(255, 255, 255)
	love.graphics.rectangle("line", map.rgrid[1] * self.grid, map.rgrid[2] * self.grid, self.grid, self.grid)

	-- draw the coords to the screen
	love.graphics.setColor(255, 255, 255)
	self:text("( " .. self.rcoords[1] .. " , " .. self.rcoords[2] .. " )", mposx + 16, mposy + 16)

	--draw the players current position // Later implement a glowing look
	love.graphics.setColor(0, 38, 255)
	love.graphics.rectangle("line", pxc * self.grid + self.view[1] + self.offset[1] - 2, pyc * self.grid + self.view[2] + self.offset[2] - 2, self.grid + 4 , self.grid + 4)
	love.graphics.rectangle("line", pxc * self.grid + self.view[1] + self.offset[1] - 2, pyc * self.grid + self.view[2] + self.offset[2] - 2, self.grid + 4 , self.grid + 4)

	--draw the waypoint
	if self:waypointIsSet() then
		love.graphics.setColor(255, 255, 0)
		love.graphics.rectangle("line", self.waypoint[1] * self.grid + self.view[1] + self.offset[1] - 2, self.waypoint[2] * self.grid + self.view[2] + self.offset[2] - 2, self.grid + 4 , self.grid + 4)
	end
	--draw the urgents
end



function map:hoverinfo()
	for i, v in pairs(self.slist) do
		if self.rcoords[1] == v.coords[1] and self.rcoords[2] == v.coords[2] and v.hidden == false then
			self:text(v.sector, mposx + 16, mposy + 32)
			self:text(v.name, mposx + 16, mposy + 48)
			self:text(v.faction, mposx + 16, mposy + 64)
			self:text(v.status, mposx + 16, mposy + 80)
		end
	end
end

function map:setwaypoint() --to be used later using the get rect info
	if self.rcoords[1] == self.waypoint[1] and self.rcoords[2] == self.waypoint[2] then
		self.waypoint = {}
	else
	self.waypoint = self.rcoords
	end
end

function map:hidewaypoint()
	self.waypoint = {}
end

function map:waypointIsSet()
	if self.waypoint[1] ~= nil then
		return true
	end
end

function map:canJump(pcoords, hyper)
	if self:waypointIsSet() then
		if (self.waypoint[1] == pcoords[1] and self.waypoint[2] == pcoords[2]) then
			return false
		else
			return true
		end
	end
end


