player = {}

function player.load()
	player.coords = {0,0}
	player.x = 0
	player.y = 0
	player.destx = 0
	player.desty = 0
	player.width = 32
	player.height = 32
	player.state = "None"
	player.currency = 1258
	player.faction = "The Alliance"
	player.rank = "Recruit"
	player.ships = {}

	player.ship =	{id = 001,
					name = "Alliance Recon Arc44",
					model = "Fighter",
					speed = 500,
					hull = 100,
					hullcap = 100,
					shield = 10,
					shieldcap = 10,
					passengers = {{title = "Marine", class = "Military", level = 2, weapon = 5, q = 4}},
					passengerct= 4,
					passcap = 5,
					cargo = {{name = "Bulk", weight = 10, q = 1, totalweight = 10}}, --q for quantity.  When purchased, it will check if the item name exists in the list, if it does, add to quantity and weight
					cargowt = 10,
					cargocap = 20,
					weapcap = 2,
					weapcount = 2,
					hyper = 150,
					hypercap = 1000,
					weapons = {{name = "Light Blaster", firerate = 2, damage = 40, accuracy = 95, q = 2}} --each is only 20 dmg, but since theres 2 it doubles the damage
					}
	table.insert(player.ships, player.ship) --add it to the list, when the player switches ships, it will update the values(if there are upgrades and such).
	player.speed = player.ship.speed
end


--Check if the player can move
function player:canmove()
	if player.x == player.destx and player.y == player.desty then
	return true
	end
end



function player:movecheck()
	if self:canmove() == true then
		if love.keyboard.isDown("a") then
			self.state = "left"
			self.destx = self.destx - 32

		elseif love.keyboard.isDown("s") then
			self.state = "down"
			self.desty = self.desty + 32

		elseif love.keyboard.isDown("d") then
			self.state = "right"
			self.destx = self.destx + 32

		elseif love.keyboard.isDown("w") then
			self.state = "up"
			self.desty = self.desty - 32
		end
	end
end



--update player position
function player:update(dt)
	player:movecheck()
	local velocity = self.speed * dt
	local padding = self.speed / 50

--move in system
		if self.state == "right" then
			if self.x < self.destx  - padding then
				self.x = self.x + velocity
			elseif self.x >= self.destx - padding then
				self.x = self.destx
			end
		end
		if self.state == "left" then
			if self.x > self.destx + padding then
				self.x = self.x - velocity
			elseif self.x <= self.destx + padding then
				self.x = self.destx
			end
		end
		if self.state == "up" then
			if self.y > self.desty + padding then
				self.y = self.y - velocity
			elseif self.y <= self.desty + padding then
				self.y = self.desty
			end
		end
		if self.state == "down" then
			if self.y < self.desty - padding then
				self.y = self.y + velocity
			elseif self.y >= self.desty - padding then
				self.y = self.desty
			end
		end

-- move to new system

        if self.x >= 640 then
            self.x = 0
            self.destx = 0
            self.coords[1] = self.coords[1] + 1
        end
		if self.x <= -31 then
            self.x = 640-32
            self.destx = self.x
            self.coords[1] = self.coords[1] - 1
		end
        if self.y >= 640 then
            self.y = 0
            self.desty = 0
            self.coords[2] = self.coords[2] + 1
        end
		if self.y <= -31 then
            self.y = 640-32
            self.desty = self.y
            self.coords[2] = self.coords[2] - 1
		end


end


function player:draw()
	love.graphics.setColor(0,255,0)
	local r = self.width / 2
	love.graphics.circle('fill', self.x + r, self.y + r, r, 1000)
end


function player:updcoords(coords)
	self.coords = coords
	self.x = 320
	self.y = 320
	self.destx = 320
	self.desty = 320
end
