weapons = {}
materials= {}
goods = {}
ships = {}
NPCs = {}
properties = {}
mines = {}

function addMaterial(name, weight, usage, value, rarity)
	local o = {}
	o.name = name
	o.weight = weight
	o.usage = usage
	o.value = value
	o.rarity = rarity
	table.insert(materials, o)
end

function addWeapon(name, firedelay, damage, accuracy)
	local o = {}
	o.name = name
	o.firedelay = firedelay
	o.damage = damage
	o.accuracy = accuracy
	table.insert(weapons, o)
end

function addGood(name, weight, usage, value, rarity, restricted)
	local o = {}
	o.name = name
	o.weight = weight
	o.usage = usage
	o.value = value
	o.rarity = rarity
	o.restricted = restricted
	table.insert(goods, o)
end



function addProperty(name, price, rarity, income)
	local o = {}
	o.name = name
	o.price = price
	o.rarity = rarity
	o.income = income
	table.insert(mines, o)
end

function addMine(name, cost, rarity, production, quantity)
	local o = {}
	o.name = name
	o.cost = cost
	o.rarity = rarity
	o.production = production
	o.quantity = quantity
	table.insert(properties, o)
end

function addShip(name, model, speed, hull, shield, passcap, cargocap, weapslots, weapons, value, rarity, faction, restricted)
	local o = {}
	o.name = name
	o.model = model
	o.speed = speed
	o.hull = hull
	o.shield = shield
	o.passcap = passcap
	o.cargocap = cargocap
	o.weapslots = weapslots
	o.weapons = weapons
	o.value = value
	o.rarity = rarity
	o.faction = faction
	o.restricted = restricted
	table.insert(ships, o)
end


function addNPC(title, class, level, cost, weapon)
	local o = {}
	o.class = class
	o.level = level
	o.cost = cost
	o.weapon = weapon
	table.insert(NPCs, o)
end



--name, weight, usage, value, rarity
addMaterial("Durellium", 10, "Structure", 1000, 80)
addMaterial("Diasteel", 10, "Framework", 1000, 80)
addMaterial("Quantrillium", 12, "Shields", 1500, 60)
addMaterial("Vyrestine Ore", 10, "Electronics", 1000, 80)
addMaterial("Renghri Gas", 10, "Communication", 1000, 80)


--name, firedelay, damage, accuracy
addWeapon("Default Blaster", 2, 20, 99)
addWeapon("Planetary Strike Missile", 50, 2000, 100)
addWeapon("Rapid Fire Rotary Cannon 'RFRC'", .5, 5, 10)
addWeapon("Concussion Laser", 40, 1200, 80)
addWeapon("Ion Cannon", 10, 80, 90)
addWeapon("Proton Ballistics", 8, 75, 55)


--name, weight, usage, value, rarity, restricted
addGood("Water", 1, "Crop Growth", 10, 100, false)
addGood("Hedrohexamene", 1, "Pharmecutical", 110, 25, true)
addGood("Ankaart Ivory", 5, "Luxury Item", 10000, 1, false)
addGood("Catatryptic Berries", 4, "Food", 100, 88, false)

--title, class, level, cost, weapon
--civil
addNPC("Laborer", "Builder", 1, 50, 1)
addNPC("Journeyman", "Builder", 2, 120, 1)
addNPC("Engineer", "Builder",3, 200, 1)
--military
addNPC("Infantry", "Military", 1, 50, 3)
addNPC("Marine", "Military", 2, 120, 5)
addNPC("Commander", "Military",5, 500, 10)


--addProperty(name, price, rarity, income)
addProperty("Casino", 150000, 40, 150)
addProperty("Hotel", 120000, 40, 125)
addProperty("Store", 80000, 40, 75)
addProperty("Market", 99000, 40, 100)

--addMine(name, cost, rarity, production, quantity)
addMine("Durellium Mine", 250000, 10, "Durellium", 10)
addMine("Diasteel Foundry", 250000, 10, "Diasteel", 10)
addMine("Quantrillium Circuitry", 250000, 10, "Quantrillium", 10)
addMine("Vyr Quarry", 250000, 10, "Vyrestine Ore", 10)
addMine("Renghri Compressions", 250000, 10, "Renghri Gas", 10)


--name, model, speed, hull, shield, passcap, cargocap, weapslots, weapons, value, rarity, faction, restricted
--Public Ships
addShip("Denduri Starfighter", "Fighter", 100, 100, 10, 1, 20, 2, {"Default Blaster"}, 35000, 90, "Denduri Spaceworks", false)
addShip("Denduri Long Range", "Fighter", 150, 100, 50, 1, 10, 0, {}, 45000, 80, "Denduri Spaceworks", false)
addShip("Alpha-Class Shuttle", "Light Frigate", 75, 100, 25, 10, 50, 4, {"Default Blaster"}, 110000, 50, "Gentec Industries", false)
addShip("Medium Cargo Transporter", "Hauler", 50, 300, 300, 100, 10000, 0, {}, 150000, 45, "Stellar Logistics Ltd.", false)


--Alliance Ships
addShip("Alliance Recon Arc44", "Fighter", 200, 100, 10, 1, 20, 2, {"Default Blaster"}, 35000, 10, "The Alliance", true)
addShip("System Interceptor", "Fighter", 350, 100, 50, 1, 20, 2, {"Default Blaster"}, 55000, 8, "The Alliance", true)
addShip("Alliance Recon Arc44", "Light Frigate", 500, 100, 10, 1, 20, 2, {"Default Blaster"}, 35000, 10, "The Alliance", true)
addShip("Alliance Recon Arc44", "Heavy Frigate", 500, 100, 10, 1, 20, 2, {"Default Blaster"}, 35000, 10, "The Alliance", true)
addShip("Alliance Recon Arc44", "Capital Ship", 500, 100, 10, 1, 20, 2, {"Default Blaster"}, 35000, 10, "The Alliance", true)
addShip("Modular Transport Unit", "Hauler", 10, 1000, 800, 100, 200000, 0, {}, 35000000, 1, "The Alliance", true)


--Nebuli Syndicate Ships
addShip("Mark V  Interceptor", "Fighter", 200, 100, 10, 1, 20, 2, {"Default Blaster"}, 35000, 10, "Nebuli Syndicate", true)
addShip("Delta Class Sentinel", "Fighter", 350, 100, 50, 1, 20, 2, {"Default Blaster"}, 55000, 8, "Nebuli Syndicate", true)
addShip("Alliance Recon Arc44", "Light Frigate", 500, 100, 10, 1, 20, 2, {"Default Blaster"}, 35000, 10, "Nebuli Syndicate", true)
addShip("Modular Transport Unit", "Hauler", 10, 1000, 800, 100, 200000, 0, {}, 35000000, 1, "Nebuli Syndicate", true)




