system = {}
system.list = {}
local mx, my
local grid = 32
local gridc = {}
system.current = {}


function newSystem(name, sector, x, y, status, hidden, faction, wealth)
	local o = {}
	o.name = name
	o.sector = sector
	o.coords = {x,y}
	o.status = status
	o.hidden = hidden
	o.faction = faction
	o.wealth = wealth -- 0 - 10
	o.planets= {}
	o.stations = {}

	function o:createplanet(name, x, y, body, population)
		table.insert(self.planets, {name = name,
									x = x,
									y = y,
									body = body,
									population = population})
	end
	function o:createsun(name, x, y)
		table.insert(self.planets, {name = name,
									x = x,
									y = y,
									body = "Sun"})
	end
	function o:createstation(name, x, y, cat, public)
		table.insert(self.stations, {name = name,
									x = x,
									y = y,
									cat = cat,
									public = public})
	end
	function o:complete()
		table.insert(system.list, self)
	end

	return o
end


function system.load()
	starbackground = love.graphics.newImage("Images/starbackground.png")
	sunglow = love.graphics.newImage("Images/glow.png")
	sys1 = newSystem("Andromeda", "Original Colonies", 0,0, "Friendly", false, "The Alliance", 10)
	sys1:createplanet("Andromeda Prime", 15, 14, "Breathable", 1000000)
	sys1:createplanet("Alpha Moon", 15, 15, "Moon", 5800)
	sys1:createplanet("Beta Moon", 15, 13, "Moon", 2500)
	sys1:createsun("Andromeda Sun", 10, 14)
	sys1:createstation("Andromeda Trading", 10, 9, "Trading I", true)
	sys1:createstation("Andromeda Supply Depot", 15, 14, "Trading II", true)
	sys1:complete()

	sys2 = newSystem("Ankaart", "Original Colonies", 1,1, "Friendly", true, "None", 3)
	sys2:createplanet("Ankaart Gas Giant", 7, 4, "Toxic", 100)
	sys2:createplanet("Ankaart Asteroid", 8, 5, "Asteroid", 1050)
	sys2:createsun("Ankaart Sun", 5, 4)
	sys2:complete()

	sys3 = newSystem("Dark Nebula", "Nebuli Cluster",-50, -55, "Hostile", false, "Nebuli Syndicate", 1)
	sys3:createplanet("Alpha Driindhy", 14, 6, "Toxic", 100)
	sys3:createplanet("Fretlut Major", 11, 12, "Toxic", 100)
	sys3:createplanet("Fretlut Minor", 12, 13, "Toxic", 100)
	sys3:createsun("Nebula Star", 5, 4)
	sys3:complete()

	sys4 = newSystem("Enlau", "Original Colonies", 5, 5, "Neutral", true, "None", "Low")
	sys4:createplanet("Alpha Driindhy", 14, 6, "Toxic", 100)
	sys4:createplanet("Fretlut Major", 11, 12, "Toxic", 100)
	sys4:createplanet("Fretlut Minor", 12, 13, "Toxic", 100)
	sys4:createsun("Enlau Star", 5, 4)
	sys4:createsun("Enlau Star II", 10, 8)
	sys4:complete()


end


function system:hoverText(text, x, y) --Move this to a RendText file to be used by display and map, possibly menu.
	local text = text
	local ypos = y
	local xpos = x
	love.graphics.setFont(bold10)
	love.graphics.setColor(255,255,255)
	love.graphics.print(text, xpos, ypos)
end


function system:check() --expose a hidden system when entered
	if self.current.coords ~= nil then
		if self.current.hidden == true then self.current.hidden	= false end
	end
end



function system:getHover(mx, my)
	mx, my = mx, my --sets the local mouse x and y for the module
	gridc = {math.floor(mx/grid) * grid, math.floor(my/grid) * grid}
end


function system:getCurrent(x,y)
	for k, s in ipairs(self.list) do
		if s.coords[1] == x and s.coords[2] == y then
			self.current = s
			return
		end
	end
	self.current = {}
end




function system:draw()

love.graphics.setColor(255,255,255)
love.graphics.draw(starbackground, 0, 0)
local center = grid / 2
if self.current.coords ~= nil then
		for k, p in ipairs(self.current.planets) do --filter the planets
			if p.body == "Breathable" then
				love.graphics.setColor(63,108,255)
				love.graphics.circle('fill', p.x * grid + center, p.y * grid + center, 12, 100)
			end
			if p.body == "Moon" then
				love.graphics.setColor(128,128,128)
				love.graphics.circle('fill', p.x * grid + center, p.y * grid + center, 8, 100)
			end
			if p.body == "Asteroid" then
				love.graphics.setColor(64,64,64)
				love.graphics.circle('fill', p.x * grid + center, p.y * grid + center, 5, 100)
			end
			if p.body == "Sun" then
				love.graphics.setColor(255,255,255) -- adds a sun glow
				love.graphics.draw(sunglow, p.x * grid + center - 64, p.y * grid + center -64) -- adds a sun glow
				love.graphics.setColor(255,225,30)
				love.graphics.circle('fill', p.x * grid + center, p.y * grid + center, 16, 100)
			end
			if p.body == "Toxic" then
				love.graphics.setColor(255,8,0)
				love.graphics.circle('fill', p.x * grid + center, p.y * grid + center, 14, 100)
			end
		end
		for k, r in ipairs(self.current.stations) do --filter the stations
			if r.cat == "Trading I" then
				love.graphics.setColor(255,255,255)
				love.graphics.draw(trading1, r.x * grid, r.y * grid)
			end
			if r.cat == "Trading II" then
				love.graphics.setColor(255,255,255)
				love.graphics.draw(trading2, r.x * grid, r.y * grid)
			end
		end
	end
end


function system:finalLayer() --hover display
	if self.current.coords ~= nil then
		for k, p in ipairs(self.current.planets) do --filter the planets
			if p.x * grid == gridc[1] and p.y * grid == gridc[2] then
				system:hoverText(p.name, gridc[1] + 36, gridc[2] + 32)
				system:hoverText(p.body, gridc[1] + 36, gridc[2] + 44)
				if p.body ~= "Sun" then
					system:hoverText(commaFormat(p.population), gridc[1] + 36, gridc[2] + 56)
				end
			end
		end
		for k, r in ipairs(self.current.stations) do --filter the stations
			if r.x * grid == gridc[1] and r.y * grid == gridc[2] then
				system:hoverText(r.name, gridc[1] + 36, gridc[2] )
				system:hoverText(r.cat, gridc[1] + 36, gridc[2] + 12)
			end
		end
	end

	love.graphics.setColor(122, 122, 122)
	love.graphics.rectangle("line", gridc[1], gridc[2], grid, grid)
	love.graphics.setColor(255,255,255)
	love.graphics.draw(mapoverlay, 0, 0)
end


function system:info()
local population = 0
local values = {}
if self.current.coords ~= nil then
		for k, p in pairs(self.current.planets) do
			if p.body ~= "Sun" then
				population = population + p.population
			end
		end
		values = {self.current.name, self.current.status, self.current.faction, population}
		return values

	end
	values = {"Uncontrolled", "Neutral", "None", 0}
	return values
end

function commaFormat(n)
  return tostring(math.floor(n)):reverse():gsub("(%d%d%d)","%1,")
                                :gsub(",(%-?)$","%1"):reverse()
end





-- parent system update to cleanup main.lua
function system:update(x, y, mx, my) --player x and y, mouse x and y
		self:getCurrent(x, y)
		self:check()
		self:getHover(mx, my)
end